#pragma once

#include <cstdint>

class TarHandler
{
public:
    struct tar_file_header {
        char filename[100];
        char mode[8];
        char uid[8];
        char gid[8];
        char file_size[12];
        char last_modification[12];
        char checksum[8];
        char type_flag;
        char linked_file_name[100];
        char ustar_indicator[6];
        char ustar_version[2];
        char owner_user_name[32];
        char owner_group_name[32];
        char device_major_number[8];
        char device_minor_number[8];
        char filename_prefix[155];
        char padding[12];
    };

public:
    TarHandler();

    void tcp_in_handler(char* data, std::size_t size);

private:
    uint64_t decode_tar_octal(char* data, std::size_t size);

    bool check_checksum(struct tar_file_header *tar_header);

    bool tar_block_handler();

    enum {
        TAR_BLOCK_SIZE = 512
    };

    char tar_block[TAR_BLOCK_SIZE];
    std::size_t tar_index;
    std::size_t next_tar_header;
    std::size_t file_size;
    std::size_t read_byte_count;
    std::size_t processed_tar_blocks;
    std::size_t file_processed_bytes;

    bool idle;
};
